##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic image conversion file                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate image conversion from JPG, ##
## PNG, GIF, etc. into C-arrays.                                          ##
############################################################################

##
## NEW MACROS
##

## 16 colours palette
PALETTE_0=0 20  26  6  25  11 9 13 15 18  2 24 4 3  0 17  #STILL CAN ADD ONE MORE COLOR IN POS 14

## Default values
#$(eval $(call IMG2SP, SET_MASK        , none               ))  { interlaced, none }
#$(eval $(call IMG2SP, SET_EXTRAPAR    ,                    ))
#$(eval $(call IMG2SP, SET_IMG_FORMAT  , sprites            ))	{ sprites, zgtiles, screen }
#$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)         ))
#$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette ))
#$(eval $(call IMG2SP, CONVERT         , img.png , w, h, array, palette, tileset))
# generate sprite arrays of w x h (if original images is bigger then it creates several arrays)
# array is the name for the sprite array generated
# palette (optional): generate the palette
# tileset (optional): generate an array of pointers to each tile array
$(eval $(call IMG2SP, SET_MODE, 0))												# Set mode 0
$(eval $(call IMG2SP, SET_FOLDER, src/sprites/ ))								# Converted files folder (it must exist!)
$(eval $(call IMG2SP, SET_OUTPUT, c))											# Converted files in c format
# $(eval $(call IMG2SP,CONVERT_PALETTE,$(PALETTE_1),palette1))					    # Create a file with the converted palette (so can be used by the Amstrad)

$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE_0), palette_0 ))
$(eval $(call IMG2SP, SET_PALETTE_FW, $(PALETTE_0)))							# Convert using defined palette level 1 and 3
$(eval $(call IMG2SP, CONVERT, assets/mothership.png,       36, 20, spr_mothership))				# generates  3 sprites of 36x20 pixels cause the image is  108x20 pixels
$(eval $(call IMG2SP, CONVERT, assets/cloud.png,            36, 20, spr_cloud))				        # generates  2 sprites of 36x20 pixels cause the image is  108x20 pixels
$(eval $(call IMG2SP, CONVERT, assets/mothership_light.png, 14,  4, spr_mothership_light)) 	    	# generates  2 sprites of  14x4 pixels cause the image is   28x4 pixels
$(eval $(call IMG2SP, CONVERT, assets/cloud_light.png,      14,  4, spr_cloud_light)) 				# generates  2 sprites of  14x4 pixels cause the image is   28x4 pixels
$(eval $(call IMG2SP, CONVERT, assets/light.png,       		14,  2, spr_light)) 					# generates  2 sprites of  14x1 pixels cause the image is   28x1 pixels
$(eval $(call IMG2SP, CONVERT, assets/new_player.png,       16, 16, spr_player)) 				    # generates 24 sprites of 16x16 pixels cause the image is 128x48 pixels
$(eval $(call IMG2SP, CONVERT, assets/ugly_alien.png,       16, 16, spr_alien)) 				    # generates 24 sprites of 16x16 pixels cause the image is 128x48 pixels
$(eval $(call IMG2SP, CONVERT, assets/lives_human.png,      16, 16, spr_lives_human))      	    	# generates  3 sprites of  12x8 pixels cause the image is  48x16 pixels
$(eval $(call IMG2SP, CONVERT, assets/lives_alien.png,      16, 16, spr_lives_alien))      	    	# generates  3 sprites of  12x8 pixels cause the image is  48x16 pixels
$(eval $(call IMG2SP, CONVERT, assets/empty.png,     	    16, 16, spr_empty))      	        	# generates  3 sprites of  12x8 pixels cause the image is  48x16 pixels

# Enemies for the alien avatar
$(eval $(call IMG2SP, CONVERT, assets/enemies_alien.png,      20, 12, spr_enemies_alien)) 	   	    # generates 16 sprites of 20x12 pixels cause the image is  80x48 pixels
# Minions for the alien avatar
$(eval $(call IMG2SP, CONVERT, assets/minions_alien.png,     12, 12, spr_minions_alien)) 	     	# generates 16 sprites of 12x12 pixels cause the image is  48x48 pixels
# Enemies for the human avatar
$(eval $(call IMG2SP, CONVERT, assets/enemies_human.png,      20, 12, spr_enemies_human)) 	   	    # generates 16 sprites of 20x12 pixels cause the image is  80x48 pixels
# Minions for the human avatar
$(eval $(call IMG2SP, CONVERT, assets/minions_human.png,     12, 12, spr_minions_human)) 	     	# generates 16 sprites of 12x12 pixels cause the image is  48x48 pixels


# Weapons
$(eval $(call IMG2SP, CONVERT, assets/vshot.png,              2,  8, spr_vshot)) 	   				# generates  2 sprites of   2x8 pixels cause the image is    4x8 pixels
$(eval $(call IMG2SP, CONVERT, assets/hshot.png,              4,  1, spr_hshot)) 	   				# generates  3 sprites of   4x2 pixels cause the image is   12x2 pixels
$(eval $(call IMG2SP, CONVERT, assets/eggs.png,               8,  8, spr_eggs)) 	   	      		# generates  3 sprites of   8x8 pixels cause the image is   24x8 pixels
$(eval $(call IMG2SP, CONVERT, assets/rocket.png,             8, 16, spr_rocket)) 	   	      		# generates  2 sprites of  8x16 pixels cause the image is  16x16 pixels
$(eval $(call IMG2SP, CONVERT, assets/bird_product.png,       8, 16, spr_bird_product)) 	   	    # generates  2 sprites of  8x16 pixels cause the image is  16x16 pixels
$(eval $(call IMG2SP, CONVERT, assets/numbers.png,            6,  8, spr_number)) 	   				# generates 10 sprites of   6x8 pixels cause the image is   60x8 pixels
$(eval $(call IMG2SP, CONVERT, assets/bar_levels.png,         4,  8, spr_bar_level)) 				# generates  3 sprites of   4x8 pixels cause the image is   12x8 pixels
$(eval $(call IMG2SP, CONVERT, assets/star_bot.png,           12,  8, spr_star_bot)) 	    	    # generates  4 sprites of  12x8 pixels cause the image is  48x8 pixels
$(eval $(call IMG2SP, CONVERT, assets/chicken_bot.png,        12,  8, spr_chicken_bot)) 	    	# generates  4 sprites of  12x8 pixels cause the image is  48x8 pixels







##
## OLD MACROS (For compatibility)
##

## Example firmware palette definition as variable in cpct_img2tileset format

# PALETTE={0 1 3 4 7 9 10 12 13 16 19 20 21 24 25 26}

## AUTOMATED IMAGE CONVERSION EXAMPLE (Uncomment EVAL line to use)
##
##    This example would convert img/example.png into src/example.{c|h} files.
##    A C-array called pre_example[24*12*2] would be generated with the definition
##    of the image example.png in mode 0 screen pixel format, with interlaced mask.
##    The palette used for conversion is given through the PALETTE variable and
##    a pre_palette[16] array will be generated with the 16 palette colours as 
##	  hardware colour values.

#$(eval $(call IMG2SPRITES,img/example.png,0,pre,24,12,$(PALETTE),mask,src/,hwpalette))



############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macro used for conversion is IMG2SPRITES, which has up to 9 parameters:##
##  (1): Image file to be converted into C sprite (PNG, JPG, GIF, etc)    ##
##  (2): Graphics mode (0,1,2) for the generated C sprite                 ##
##  (3): Prefix to add to all C-identifiers generated                     ##
##  (4): Width in pixels of each sprite/tile/etc that will be generated   ##
##  (5): Height in pixels of each sprite/tile/etc that will be generated  ##
##  (6): Firmware palette used to convert the image file into C values    ##
##  (7): (mask / tileset / zgtiles)                                       ##
##     - "mask":    generate interlaced mask for all sprites converted    ##
##     - "tileset": generate a tileset array with pointers to all sprites ##
##     - "zgtiles": generate tiles/sprites in Zig-Zag pixel order and     ##
##                  Gray Code row order                                   ##
##  (8): Output subfolder for generated .C/.H files (in project folder)   ##
##  (9): (hwpalette)                                                      ##
##     - "hwpalette": output palette array with hardware colour values    ##
## (10): Aditional options (you can use this to pass aditional modifiers  ##
##       to cpct_img2tileset)                                             ##
##                                                                        ##
## Macro is used in this way (one line for each image to be converted):   ##
##  $(eval $(call IMG2SPRITES,(1),(2),(3),(4),(5),(6),(7),(8),(9), (10))) ##
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/sprites,... will represent "src/sprites"   ##
##    folder, whereas ...,  src/sprites,... means "  src/sprites" folder. ##
##                                                                        ##
##  * You can omit parameters but leaving them empty. Therefore, if you   ##
##  wanted to specify an output folder but do not want your sprites to    ##
##  have mask and/or tileset, you may omit parameter (7) leaving it empty ##
##     $(eval $(call IMG2SPRITES,imgs/1.png,0,g,4,8,$(PAL),,src/))        ##
############################################################################
