//-----------------------------LICENSE NOTICE------------------------------------
//
////////////////////////////////////////////////////////////////////////////////
///////////////////////////  SHOOT AND RUN /////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
//
//  Code & Graphics Copyright (C) 2020 Rafa Gutierrez (rafagutierrez@qq.com)
//
//  This file is part of Shoot and run: an Amstrad CPC Game made with CPCTelera
//  for CPCRetroDev 2020
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.


#include "custom_sprites.h"

// MODE 0 codification
//
// Vertical white shoot 1 for player
// Left pixel color 2 (white), right pixel color 0 (black)
// _LP_ _RP_  0 2 1 3   (LP=Left pixel, RP=Right pixel)
// 3210 DCBA   A C B D  (Bit order 0A2C1B3D)
// 0010 0000  00001000 = 0x08        

// Vertical white shoot 2 for player
// Left pixel color 0 (black), right pixel color 2 (white)
// _LP_ _RP_  0 2 1 3   (LP=Left pixel, RP=Right pixel)
// 3210 DCBA   A C B D  (Bit order 0A2C1B3D)
// 0000 0010  00000100 = 0x04             

// Vertical yellow shoot for alien spaceship
// Left pixel color 4 (yellow), right pixel color 0 (black)
// _LP_ _RP_  0 2 1 3   (LP=Left pixel, RP=Right pixel)
// 3210 DCBA   A C B D  (Bit order 0A2C1B3D)
// 0100 0000  00100000 = 0x20

// Vertical blue shoot for alien spaceship
// Left pixel color 5 (blue), right pixel color 0 (black)
// _LP_ _RP_  0 2 1 3   (LP=Left pixel, RP=Right pixel)
// 3210 DCBA   A C B D  (Bit order 0A2C1B3D)
// 0101 0000  10100000 = 0xA0

// Vertical white shoot 1 for player
// spr_vshot_1: 1x8 pixels, 1x8 bytes. (left pixel: white, right pixel: black)
const u8 spr_player_vshot_lp[1 * 8] = {
	0x08,
	0x08,
	0x08,
	0x08,
	0x08,
	0x08,
	0x08,
	0x08
};

// Vertical white shoot 2 for player
// spr_vshot_1: 1x8 pixels, 1x8 bytes. (left pixel: black, right pixel: white)
const u8 spr_player_vshot_rp[1 * 8] = {
	0x04,
	0x04,
	0x04,
	0x04,
	0x04,
	0x04,
	0x04,
	0x04
};

// Vertical yellow shoot for alien spaceship
// spr_vshot_1: 1x8 pixels, 1x8 bytes. (left pixel: black, right pixel: white)
const u8 spr_vshot_3[1 * 8] = {
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20

};


// Vertical blue shoot for alien spaceship
// spr_vshot_1: 1x8 pixels, 1x8 bytes. (left pixel: black, right pixel: white)
const u8 spr_vshot_2[1 * 8] = {
	0xA0,
	0xA0,
	0xA0,
	0xA0,
	0xA0,
	0xA0,
	0xA0,
	0xA0

};
