//-----------------------------LICENSE NOTICE------------------------------------
//
////////////////////////////////////////////////////////////////////////////////
///////////////////////////  SHOOT AND RUN /////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
//
//  Code & Graphics Copyright (C) 2020 Rafa Gutierrez (rafagutierrez@qq.com)
//
//  This file is part of Shoot and run: an Amstrad CPC Game made with CPCTelera
//  for CPCRetroDev 2020
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.


#pragma once
#include <man/entity.h>

//==============================================================================
// PUBLIC CONSTANTS
//==============================================================================

// Y scoreboard
#define SCOREBOARD_Y                        0       // Y coord of scoreboard

// Y lanes
#define LANE_DY                             25      // Distance between to consecutive lanes
#define LANE2_Y                             50      // Y coord of top lane
#define LANE1_Y  (LANE2_Y + LANE_DY)                // Y coord of middle lane
#define LANE0_Y  (LANE2_Y + 2*(LANE_DY))            // Y coord of bottom lane

// X positions
#define SCOREBOARD_X                        28      // X coord of scoreboard
#define SCOREBOARD_DX                        4      // Distance between to consecutive digits
#define MOTHERSHIP_X                        36
#define PLAYER_X                            36
#define LIVES_X                              4
#define LIVES_DX                             2      // Distance between two player lives sprites
#define TEMP_BAR_X                          50

// Y positions
#define MOTHERSHIP_Y                        16
#define PLAYER_Y                           162
#define LIVES_Y                            184
#define TEMP_BAR_Y                         188
#define PLAYERVSHOT_Y  (PLAYER_Y - 8)
#define PLAYERHSHOT_Y  (PLAYER_Y + 3)

// Animation status
#define STANDING                             0
#define WALKING_LEFT                         1 
#define WALKING_RIGHT                        2

//------------------------------------------------------------------------------
// Entity templates
extern const Entity_t mothership_tmpl;
extern const Entity_t cloud_tmpl;
extern const Entity_t light_tmpl;   
extern const Entity_t mothership_light_tmpl;   
extern const Entity_t cloud_light_tmpl;                        
extern const Entity_t alien_enemy1_tmpl;
extern const Entity_t alien_enemy2_tmpl;
extern const Entity_t alien_enemy3_tmpl;
extern const Entity_t alien_enemy4_tmpl;
extern const Entity_t alien_minion1_tmpl;
extern const Entity_t alien_minion2_tmpl;
extern const Entity_t alien_minion3_tmpl;
extern const Entity_t alien_minion4_tmpl;
extern const Entity_t human_enemy1_tmpl;
extern const Entity_t human_enemy2_tmpl;
extern const Entity_t human_enemy3_tmpl;
extern const Entity_t human_enemy4_tmpl;
extern const Entity_t human_minion1_tmpl;
extern const Entity_t human_minion2_tmpl;
extern const Entity_t human_minion3_tmpl;
extern const Entity_t human_minion4_tmpl;

extern const Entity_t player0_tmpl;
extern const Entity_t human_tmpl;
extern const Entity_t alien_tmpl;
extern const Entity_t lives_human_tmpl;
extern const Entity_t lives_alien_tmpl;
extern const Entity_t enemyshot1_tmpl;
extern const Entity_t enemyshot2_tmpl;
extern const Entity_t eggshot1_tmpl;
extern const Entity_t eggshot2_tmpl;
extern const Entity_t enemyrocket_tmpl;
extern const Entity_t bird_product_tmpl;
extern const Entity_t enemybot_tmpl;
extern const Entity_t chickenbot_tmpl;
extern const Entity_t playervshot_tmpl;
extern const Entity_t playerhshot_tmpl;
extern const Entity_t bar_tmpl;
extern const Entity_t digit_tmpl;
extern const Entity_t flash_tmpl;