//-----------------------------LICENSE NOTICE------------------------------------
//
////////////////////////////////////////////////////////////////////////////////
///////////////////////////  SHOOT AND RUN /////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
//
//  Code & Graphics Copyright (C) 2020 Rafa Gutierrez (rafagutierrez@qq.com)
//
//  This file is part of Shoot and run: an Amstrad CPC Game made with CPCTelera
//  for CPCRetroDev 2020
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.


#pragma once                    // to avoid including several times
#include <cpctelera.h>
#include <man/entity.h>


//==============================================================================
// PUBLIC CONSTANTS
//==============================================================================
//
#define MAX_LEVELS                  12
//------------------------------------------------------------------------------
// Entity_t Types (used as bit masks)
#define e_type_invalid             0x00    // Invalid entity type. Entity does not exist
#define e_type_player              0x01    // 




//==============================================================================
// PUBLIC DATA STRUCTURES
//==============================================================================
//
//------------------------------------------------------------------------------
// Forward declarations of structures and type definitions
// Score Digits Structure
typedef struct level_t level_t;   

struct level_t {           
    u8                  num;
    u8                  enemies_created; 
    u8                  enemies_killed; 
    u8                  id_palette;
    u8                  bouncing_on;                // true or false    REMOVE FROM GAME_INIT SINCE THEY ARE FROM EACH LEVEL
    u8                  hidding_on;                 // true or false
    u8                  ai_level;                   //
};

extern level_t level;



/// ALL THESE INSIDE THE LEVEL_T STRUCTURE AND REFERENCE IN GAME, AI AND RENDER USED level->num instead of m_level
//extern u8          m_level;                      // current level
extern u8          m_level_enemies_killed;       // num of enemies killed  in current level
extern u8          m_level_created_enemies;      // num of enemies created in current level

//==============================================================================
// PUBLIC INTERFACE
//==============================================================================
void man_level_setup(u8 i);                              

void man_level_set_enemy_death(Entity_t* e);

u8 m_level_last_kill();             
        
BehaviourFunc_t man_level_lane0_ai();
Entity_t*       man_level_create_enemy();
Entity_t*       man_level_create_minion();
Entity_t*       man_level_create_enemy_attack(u8 x);