//-----------------------------LICENSE NOTICE------------------------------------
//
////////////////////////////////////////////////////////////////////////////////
///////////////////////////  SHOOT AND RUN /////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
//
//  Code & Graphics Copyright (C) 2020 Rafa Gutierrez (rafagutierrez@qq.com)
//
//  This file is part of Shoot and run: an Amstrad CPC Game made with CPCTelera
//  for CPCRetroDev 2020
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.


#pragma once
#include <cpctelera.h>
#include <man/entity.h>


//==============================================================================
// PUBLIC CONSTANTS
//==============================================================================
//
//------------------------------------------------------------------------------
// TIMERS
#define SYS_AI_ENEMY_DEATH                  20
#define SYS_AI_PLAYER_DEATH                 20
#define SYS_AI_BAR_TIMER                    50
#define SYS_AI_SHOOTER_TIMER                30 
#define SYS_AI_MOTHERSHIP_FROZEN            20
#define SYS_AI_SWITCH_TIME                  30              // for now using the variable hidden_counter

// Enemies behaviours
#define SYS_AI_DEFENSIVE                     0
#define SYS_AI_REGULAR                       1
#define SYS_AI_AGGRESSIVE                    2

#define IS_SHOT_BOT                         (e_type_player_vshot | e_type_player_hshot | e_type_enemy_shot | e_type_enemy_bot )

// Light
#define LIGHT_Y                             34
#define LIGHT_H                            142

//==============================================================================
// PUBLIC INTERFACE
//==============================================================================
void sys_ai_init();
void sys_ai_update();

void sys_ai_behaviour_mothership(Entity_t* e);
void sys_ai_behaviour_mothership_abduces(Entity_t* e);
void sys_ai_behaviour_enemy(Entity_t* e);
void sys_ai_behaviour_bouncing_enemy(Entity_t* e);
void sys_ai_behaviour_shooter(Entity_t* e);
void sys_ai_behaviour_bot(Entity_t* e);
void sys_ai_behaviour_deploy_bot(Entity_t* e);
void sys_ai_behaviour_autodestroy_by_t(Entity_t* e);
void sys_ai_behaviour_autodestroy_by_x(Entity_t* e);
void sys_ai_behaviour_render_delay(Entity_t* e);
void sys_ai_behaviour_light(Entity_t* e);
void sys_ai_behaviour_bar(Entity_t* e);
void sys_ai_behaviour_flash(Entity_t* e);
void sys_ai_switch_render(Entity_t* e);

void sys_ai_behaviour_player_dies(Entity_t* e);
void sys_ai_behaviour_enemy_dies(Entity_t* e);
void sys_ai_behaviour_enemy_splits(Entity_t* e);

void sys_ai_behaviour_player_zero(Entity_t* e);

// TEMP
extern u8 hidden_counter;