//-----------------------------LICENSE NOTICE------------------------------------
//
////////////////////////////////////////////////////////////////////////////////
///////////////////////////  SHOOT AND RUN /////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
//
//  Code & Graphics Copyright (C) 2020 Rafa Gutierrez (rafagutierrez@qq.com)
//
//  This file is part of Shoot and run: an Amstrad CPC Game made with CPCTelera
//  for CPCRetroDev 2020
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.


#include "input.h"
#include <man/game.h>


//==============================================================================
//==============================================================================
// PUBLIC FUNCTIONS
//==============================================================================
//==============================================================================

u8 sys_input_status;    

// sys_inputs_status
// 0000 No    key pressed
// 0001 Left  key pressed
// 0010 Right key pressed
// 0100 Up    key pressed
// 1000 Fire  key pressed

////////////////////////////////////////////////////////////////////////////////
// UPDATE
//      Updates the input status
//
void sys_input_update() {

    sys_input_status = 0;

    cpct_scanKeyboard_f();

    if (cpct_isKeyPressed(Key_O))       sys_input_status |= 0x01;
    if (cpct_isKeyPressed(Key_P))       sys_input_status |= 0x02;
    if (cpct_isKeyPressed(Key_Q))       sys_input_status |= 0x04;
    if (cpct_isKeyPressed(Key_Space))   sys_input_status |= 0x08;

}


////////////////////////////////////////////////////////////////////////////////
// INIT
//      Initialize the input status
//
void sys_input_init() {

    sys_input_status = 0;

}
